module Trie (Trie, empty, insert, delete, lookup, (!),
             toList, keys, fromList) where

import Prelude hiding (lookup, null)
import qualified Data.Map as M

empty    :: Trie alpha beta
insert   :: Ord alpha => [alpha]-> beta -> Trie alpha beta -> Trie alpha beta
delete   :: Ord alpha => [alpha] -> Trie alpha beta -> Trie alpha beta
lookup   :: Ord alpha => [alpha] -> Trie alpha beta -> Maybe beta
(!)      :: Ord alpha => Trie alpha beta -> [alpha] -> beta
toList   :: Trie alpha beta -> [([alpha], beta)]
keys     :: Trie alpha beta -> [[alpha]]
fromList :: Ord alpha => [([alpha], beta)] -> Trie alpha beta

-- Mit dem eigenen Datentyp ersetzen!
data Trie alpha beta = Node deriving Show

instance (Eq alpha, Eq beta) => Eq (Trie alpha beta) where
  t1 == t2 = undefined

empty = undefined

insert = undefined

null = undefined

lookup = undefined

t ! x =  undefined
 
delete = undefined

toList = undefined

fromList l = undefined

keys = undefined

